//---------------------------------------------------------------------------

#include "stdafx.h"

using namespace std;

#ifdef _MSC_VER
#pragma hdrstop
#endif

#include "myExcept.h"
#include "bitvector.h"
#include "Cube.h"
#include "mytime.h"

#include <ctime>
#include <cstdio>
#include "perfcounter.h"


Delays g_delays;

Delays::~Delays() {
	for (map<string, ULONG64>::const_iterator it = delays.begin();
		it != delays.end(); ++it)
			cout << it->first << " " << (int)it->second << "\n";
}
void Delays::add(const std::string & name, ULONG64 count) {
	if (delays.find(name) == delays.end())
		delays[name] = count;
	else
		delays[name] = delays[name] + count;
}

TimeCntr::TimeCntr(const char* name) {
	this->name = name;
//	cnt2 = GetTickCount();
	QueryPerformanceCounter(&cnt);
//	cnt3 = GetMyCPUTime2();
}
TimeCntr::~TimeCntr() {
	LARGE_INTEGER now;
	QueryPerformanceCounter(&now);

	g_delays.add(name, now.QuadPart - cnt.QuadPart);
	//g_delays.add(name, GetTickCount() - cnt2);
	//g_delays.add(name, GetMyCPUTime2() - cnt3);
}

double GetMyCPUTime2(void)
{
	HANDLE hProcess;	// specifies the process of interest
    FILETIME lpCreationTime;	// when the process was created
    FILETIME lpExitTime;	// when the process exited
    FILETIME lpKernelTime;	// time the process has spent in kernel mode
    FILETIME lpUserTime;
    LARGE_INTEGER t1, t2;

    hProcess = GetCurrentProcess();
    GetProcessTimes(hProcess, &lpCreationTime, &lpExitTime, &lpKernelTime, &lpUserTime);
    memcpy(&t1, &lpUserTime, sizeof(FILETIME));
    memcpy(&t2, &lpKernelTime, sizeof(FILETIME));
    return ((double)(t1.QuadPart+t2.QuadPart)/10000000);
}

ULONG64 GetMyCPUTime3(void)
{
	ULONG64 cycles = 0;
//	QueryProcessCycleTime(GetCurrentProcess(), &cycles);
    return cycles;
}
