#include "stdafx.h"
#include <iostream>
#include <stack>
#include <sstream>
#include <math.h>
#include <string>
#include <fstream>
using namespace std;

#include "myExcept.h"
#include "PLA_type.h"
#include "bitvector.h"
#include "Term.h"
#include "utils.h"
#include "TTree.h"
#include "Graph.h"

#include "PLA.h"
#include "graph.h"

int main(int argc, char* argv[])
{
	if (argc < 2)
		return -1;

	PLA *pla = new PLA();
	pla->LoadPLA(argv[1]);

	Graph *g = new Graph();
	g->ConstructFromBoomPLA(pla);
	cout << g->GenerateStreamForPLA();

	//Graph *h = g->Complement();
	//PLA *pla2 = h->GetPLA();
	//pla2->SavePLA("vystup");

	//g->Orthogonalization(false);
	//PLA *pla3 = g->GetPLA(pla);
	//pla3->SavePLA("vystup2");

	g->Minimization(false);
	PLA *pla4 = g->GetPLA(pla);
	pla4->SavePLA("vystup3");
	

	system("PAUSE");
	return 0;
}