library IEEE;
use IEEE.std_logic_1164.all;

entity output.neco is
   port( x0, x1, x2, x3, x4, x5, x6, x7, x8, x9: in std_logic;
         y0, y1, y2, y3, y4, y5, y6, y7, y8, y9, y10, y11: out std_logic);
end ;

architecture PLA of  is
   signal t_0, t_1, t_2, t_3, t_4, t_5, t_6, t_7, t_8, t_9, t_10, t_11, t_12, t_13, t_14, t_15, t_16, t_17, t_18, t_19, t_20, t_21, t_22, t_23, t_24, t_25, t_26, t_27, t_28, t_29, t_30, t_31, t_32, t_33, t_34, t_35, t_36, t_37, t_38, t_39, t_40, t_41, t_42, t_43, t_44, t_45, t_46, t_47, t_48, t_49, t_50, t_51, t_52, t_53, t_54, t_55, t_56, t_57, t_58, t_59, t_60, t_61, t_62, t_63, t_64, t_65, t_66, t_67, t_68, t_69, t_70, t_71, t_72, t_73, t_74, t_75, t_76, t_77, t_78, t_79, t_80, t_81, t_82, t_83, t_84, t_85, t_86, t_87, t_88, t_89, t_90, t_91, t_92, t_93, t_94, t_95, t_96, t_97, t_98, t_99, t_100, t_101, t_102, t_103, t_104, t_105, t_106, t_107, t_108, t_109, t_110, t_111, t_112, t_113, t_114, t_115, t_116, t_117, t_118, t_119, t_120, t_121, t_122, t_123, t_124, t_125, t_126, t_127, t_128, t_129, t_130, t_131, t_132, t_133: std_logic;
   signal n_x0, n_x1, n_x2, n_x3, n_x4, n_x5, n_x6, n_x7, n_x8, n_x9: std_logic;

begin
   n_x0 <= not x0;
   n_x1 <= not x1;
   n_x2 <= not x2;
   n_x3 <= not x3;
   n_x4 <= not x4;
   n_x5 <= not x5;
   n_x6 <= not x6;
   n_x7 <= not x7;
   n_x8 <= not x8;
   n_x9 <= not x9;

   t_0 <= n_x0 and x1 and n_x2 and n_x3 and n_x4 and n_x5 and n_x6 and n_x7 and n_x8 and n_x9;
   t_1 <= n_x0 and n_x1 and n_x2 and n_x3 and x4 and n_x5 and n_x6 and n_x7 and n_x8 and n_x9;
   t_2 <= n_x0 and n_x1 and n_x2 and n_x3 and n_x4 and x5 and n_x6 and n_x7 and n_x8 and n_x9;
   t_3 <= x0 and n_x1 and n_x2 and n_x3 and n_x4 and n_x5 and n_x6 and n_x7 and n_x8 and n_x9;
   t_4 <= n_x0 and n_x1 and x2 and n_x3 and n_x4 and n_x5 and n_x6 and n_x7 and n_x8 and n_x9;
   t_5 <= n_x0 and n_x1 and n_x2 and x3 and n_x4 and n_x5 and n_x6 and n_x7 and n_x8 and n_x9;
   t_6 <= n_x0 and n_x1 and n_x2 and n_x3 and n_x4 and n_x5 and x6 and n_x7 and n_x8 and n_x9;
   t_7 <= x0 and n_x1 and n_x2 and n_x3 and n_x4 and n_x5 and n_x6 and n_x7 and n_x8 and n_x9;
   t_8 <= n_x0 and n_x1 and n_x2 and x3 and n_x4 and n_x5 and n_x6 and n_x7 and n_x8 and n_x9;
   t_9 <= n_x0 and x1 and n_x2 and n_x3 and n_x4 and n_x5 and n_x6 and n_x7 and n_x8 and n_x9;
   t_10 <= n_x0 and n_x1 and n_x2 and n_x3 and x4 and n_x5 and n_x6 and n_x7 and n_x8 and n_x9;
   t_11 <= n_x0 and n_x1 and n_x2 and n_x3 and n_x4 and x5 and n_x6 and n_x7 and n_x8 and n_x9;
   t_12 <= n_x0 and n_x1 and x2 and n_x3 and n_x4 and n_x5 and n_x6 and n_x7 and n_x8 and n_x9;
   t_13 <= n_x0 and n_x1 and n_x2 and n_x3 and n_x4 and n_x5 and x6 and n_x7 and n_x8 and n_x9;
   t_14 <= n_x0 and x1 and n_x2 and n_x3 and n_x4 and n_x5 and n_x6 and n_x7 and n_x8 and x9;
   t_15 <= n_x0 and n_x1 and n_x2 and n_x3 and x4 and n_x5 and n_x6 and n_x7 and n_x8 and x9;
   t_16 <= n_x0 and n_x1 and n_x2 and n_x3 and n_x4 and x5 and n_x6 and n_x7 and n_x8 and x9;
   t_17 <= x0 and n_x1 and n_x2 and n_x3 and n_x4 and n_x5 and n_x6 and n_x7 and n_x8 and x9;
   t_18 <= n_x0 and n_x1 and x2 and n_x3 and n_x4 and n_x5 and n_x6 and n_x7 and n_x8 and x9;
   t_19 <= n_x0 and n_x1 and n_x2 and x3 and n_x4 and n_x5 and n_x6 and n_x7 and n_x8 and x9;
   t_20 <= n_x0 and n_x1 and n_x2 and n_x3 and n_x4 and n_x5 and x6 and n_x7 and n_x8 and x9;
   t_21 <= x0 and n_x1 and n_x2 and n_x3 and n_x4 and n_x5 and n_x6 and n_x7 and n_x8 and x9;
   t_22 <= n_x0 and n_x1 and n_x2 and x3 and n_x4 and n_x5 and n_x6 and n_x7 and n_x8 and x9;
   t_23 <= n_x0 and x1 and n_x2 and n_x3 and n_x4 and n_x5 and n_x6 and n_x7 and n_x8 and x9;
   t_24 <= n_x0 and n_x1 and n_x2 and n_x3 and x4 and n_x5 and n_x6 and n_x7 and n_x8 and x9;
   t_25 <= n_x0 and n_x1 and n_x2 and n_x3 and n_x4 and x5 and n_x6 and n_x7 and n_x8 and x9;
   t_26 <= n_x0 and n_x1 and x2 and n_x3 and n_x4 and n_x5 and n_x6 and n_x7 and n_x8 and x9;
   t_27 <= n_x0 and n_x1 and n_x2 and n_x3 and n_x4 and n_x5 and x6 and n_x7 and n_x8 and x9;
   t_28 <= n_x0 and n_x1 and n_x2 and n_x3 and x4 and n_x5 and n_x6 and n_x7 and x8 and n_x9;
   t_29 <= n_x0 and n_x1 and n_x2 and n_x3 and n_x4 and x5 and n_x6 and n_x7 and x8 and n_x9;
   t_30 <= n_x0 and n_x1 and n_x2 and n_x3 and n_x4 and n_x5 and x6 and n_x7 and x8 and n_x9;
   t_31 <= x0 and n_x1 and n_x2 and n_x3 and n_x4 and n_x5 and n_x6 and n_x7 and x8 and n_x9;
   t_32 <= n_x0 and x1 and n_x2 and n_x3 and n_x4 and n_x5 and n_x6 and n_x7 and x8 and n_x9;
   t_33 <= n_x0 and n_x1 and x2 and n_x3 and n_x4 and n_x5 and n_x6 and n_x7 and x8 and n_x9;
   t_34 <= n_x0 and n_x1 and n_x2 and x3 and n_x4 and n_x5 and n_x6 and n_x7 and x8 and n_x9;
   t_35 <= n_x0 and x1 and n_x2 and n_x3 and n_x4 and n_x5 and n_x6 and n_x7 and x8 and n_x9;
   t_36 <= n_x0 and n_x1 and n_x2 and x3 and n_x4 and n_x5 and n_x6 and n_x7 and x8 and n_x9;
   t_37 <= x0 and n_x1 and n_x2 and n_x3 and n_x4 and n_x5 and n_x6 and n_x7 and x8 and n_x9;
   t_38 <= n_x0 and n_x1 and x2 and n_x3 and n_x4 and n_x5 and n_x6 and n_x7 and x8 and n_x9;
   t_39 <= n_x0 and n_x1 and n_x2 and n_x3 and x4 and n_x5 and n_x6 and n_x7 and x8 and n_x9;
   t_40 <= n_x0 and n_x1 and n_x2 and n_x3 and n_x4 and x5 and n_x6 and n_x7 and x8 and n_x9;
   t_41 <= n_x0 and n_x1 and n_x2 and n_x3 and n_x4 and n_x5 and x6 and n_x7 and x8 and n_x9;
   t_42 <= n_x0 and n_x1 and n_x2 and n_x3 and x4 and n_x5 and n_x6 and n_x7 and x8 and x9;
   t_43 <= n_x0 and n_x1 and n_x2 and n_x3 and n_x4 and x5 and n_x6 and n_x7 and x8 and x9;
   t_44 <= n_x0 and n_x1 and n_x2 and n_x3 and n_x4 and n_x5 and x6 and n_x7 and x8 and x9;
   t_45 <= x0 and n_x1 and n_x2 and n_x3 and n_x4 and n_x5 and n_x6 and n_x7 and x8 and x9;
   t_46 <= n_x0 and n_x1 and x2 and n_x3 and n_x4 and n_x5 and n_x6 and n_x7 and x8 and x9;
   t_47 <= n_x0 and x1 and n_x2 and n_x3 and n_x4 and n_x5 and n_x6 and n_x7 and x8 and x9;
   t_48 <= n_x0 and n_x1 and n_x2 and x3 and n_x4 and n_x5 and n_x6 and n_x7 and x8 and x9;
   t_49 <= n_x0 and x1 and n_x2 and n_x3 and n_x4 and n_x5 and n_x6 and n_x7 and x8 and x9;
   t_50 <= n_x0 and n_x1 and n_x2 and x3 and n_x4 and n_x5 and n_x6 and n_x7 and x8 and x9;
   t_51 <= x0 and n_x1 and n_x2 and n_x3 and n_x4 and n_x5 and n_x6 and n_x7 and x8 and x9;
   t_52 <= n_x0 and n_x1 and x2 and n_x3 and n_x4 and n_x5 and n_x6 and n_x7 and x8 and x9;
   t_53 <= n_x0 and n_x1 and n_x2 and n_x3 and x4 and n_x5 and n_x6 and n_x7 and x8 and x9;
   t_54 <= n_x0 and n_x1 and n_x2 and n_x3 and n_x4 and x5 and n_x6 and n_x7 and x8 and x9;
   t_55 <= n_x0 and n_x1 and n_x2 and n_x3 and n_x4 and n_x5 and x6 and n_x7 and x8 and x9;
   t_56 <= n_x0 and x1 and n_x2 and n_x3 and n_x4 and n_x5 and n_x6 and x7 and n_x8 and n_x9;
   t_57 <= n_x0 and n_x1 and n_x2 and n_x3 and x4 and n_x5 and n_x6 and x7 and n_x8 and n_x9;
   t_58 <= x0 and n_x1 and n_x2 and n_x3 and n_x4 and n_x5 and n_x6 and x7 and n_x8 and n_x9;
   t_59 <= n_x0 and n_x1 and x2 and n_x3 and n_x4 and n_x5 and n_x6 and x7 and n_x8 and n_x9;
   t_60 <= n_x0 and n_x1 and n_x2 and x3 and n_x4 and n_x5 and n_x6 and x7 and n_x8 and n_x9;
   t_61 <= n_x0 and n_x1 and n_x2 and n_x3 and n_x4 and x5 and n_x6 and x7 and n_x8 and n_x9;
   t_62 <= n_x0 and n_x1 and n_x2 and n_x3 and n_x4 and n_x5 and x6 and x7 and n_x8 and n_x9;
   t_63 <= n_x0 and x1 and n_x2 and n_x3 and n_x4 and n_x5 and n_x6 and x7 and n_x8 and n_x9;
   t_64 <= n_x0 and n_x1 and n_x2 and n_x3 and x4 and n_x5 and n_x6 and x7 and n_x8 and n_x9;
   t_65 <= x0 and n_x1 and n_x2 and n_x3 and n_x4 and n_x5 and n_x6 and x7 and n_x8 and n_x9;
   t_66 <= n_x0 and n_x1 and x2 and n_x3 and n_x4 and n_x5 and n_x6 and x7 and n_x8 and n_x9;
   t_67 <= n_x0 and n_x1 and n_x2 and x3 and n_x4 and n_x5 and n_x6 and x7 and n_x8 and n_x9;
   t_68 <= n_x0 and n_x1 and n_x2 and n_x3 and n_x4 and x5 and n_x6 and x7 and n_x8 and n_x9;
   t_69 <= n_x0 and n_x1 and n_x2 and n_x3 and n_x4 and n_x5 and x6 and x7 and n_x8 and n_x9;
   t_70 <= n_x0 and x1 and n_x2 and n_x3 and n_x4 and n_x5 and n_x6 and x7 and n_x8 and x9;
   t_71 <= n_x0 and n_x1 and n_x2 and n_x3 and x4 and n_x5 and n_x6 and x7 and n_x8 and x9;
   t_72 <= x0 and n_x1 and n_x2 and n_x3 and n_x4 and n_x5 and n_x6 and x7 and n_x8 and x9;
   t_73 <= n_x0 and n_x1 and x2 and n_x3 and n_x4 and n_x5 and n_x6 and x7 and n_x8 and x9;
   t_74 <= n_x0 and n_x1 and n_x2 and x3 and n_x4 and n_x5 and n_x6 and x7 and n_x8 and x9;
   t_75 <= n_x0 and n_x1 and n_x2 and n_x3 and n_x4 and x5 and n_x6 and x7 and n_x8 and x9;
   t_76 <= n_x0 and n_x1 and n_x2 and n_x3 and n_x4 and n_x5 and x6 and x7 and n_x8 and x9;
   t_77 <= x0 and n_x1 and n_x2 and n_x3 and n_x4 and n_x5 and n_x6 and x7 and n_x8 and x9;
   t_78 <= n_x0 and n_x1 and n_x2 and x3 and n_x4 and n_x5 and n_x6 and x7 and n_x8 and x9;
   t_79 <= n_x0 and x1 and n_x2 and n_x3 and n_x4 and n_x5 and n_x6 and x7 and n_x8 and x9;
   t_80 <= n_x0 and n_x1 and n_x2 and n_x3 and x4 and n_x5 and n_x6 and x7 and n_x8 and x9;
   t_81 <= n_x0 and n_x1 and x2 and n_x3 and n_x4 and n_x5 and n_x6 and x7 and n_x8 and x9;
   t_82 <= n_x0 and n_x1 and n_x2 and n_x3 and n_x4 and n_x5 and x6 and x7 and n_x8 and x9;
   t_83 <= n_x0 and n_x1 and n_x2 and n_x3 and n_x4 and x5 and n_x6 and x7 and n_x8 and x9;
   t_84 <= n_x0 and x1 and n_x2 and n_x3 and n_x4 and n_x5 and n_x6 and x7 and x8 and n_x9;
   t_85 <= n_x0 and n_x1 and n_x2 and n_x3 and x4 and n_x5 and n_x6 and x7 and x8 and n_x9;
   t_86 <= n_x0 and n_x1 and n_x2 and n_x3 and n_x4 and x5 and n_x6 and x7 and x8 and n_x9;
   t_87 <= n_x0 and n_x1 and n_x2 and n_x3 and n_x4 and n_x5 and x6 and x7 and x8 and n_x9;
   t_88 <= x0 and n_x1 and n_x2 and n_x3 and n_x4 and n_x5 and n_x6 and x7 and x8 and n_x9;
   t_89 <= n_x0 and n_x1 and x2 and n_x3 and n_x4 and n_x5 and n_x6 and x7 and x8 and n_x9;
   t_90 <= n_x0 and n_x1 and n_x2 and x3 and n_x4 and n_x5 and n_x6 and x7 and x8 and n_x9;
   t_91 <= n_x0 and x1 and n_x2 and n_x3 and n_x4 and n_x5 and n_x6 and x7 and x8 and n_x9;
   t_92 <= x0 and n_x1 and n_x2 and n_x3 and n_x4 and n_x5 and n_x6 and x7 and x8 and n_x9;
   t_93 <= n_x0 and n_x1 and x2 and n_x3 and n_x4 and n_x5 and n_x6 and x7 and x8 and n_x9;
   t_94 <= n_x0 and n_x1 and n_x2 and n_x3 and x4 and n_x5 and n_x6 and x7 and x8 and n_x9;
   t_95 <= n_x0 and n_x1 and n_x2 and n_x3 and n_x4 and x5 and n_x6 and x7 and x8 and n_x9;
   t_96 <= n_x0 and n_x1 and n_x2 and n_x3 and n_x4 and n_x5 and x6 and x7 and x8 and n_x9;
   t_97 <= n_x0 and n_x1 and n_x2 and x3 and n_x4 and n_x5 and n_x6 and x7 and x8 and n_x9;
   t_98 <= n_x0 and x1 and n_x2 and n_x3 and n_x4 and n_x5 and n_x6 and x7 and x8 and x9;
   t_99 <= n_x0 and n_x1 and n_x2 and n_x3 and x4 and n_x5 and n_x6 and x7 and x8 and x9;
   t_100 <= n_x0 and n_x1 and n_x2 and n_x3 and n_x4 and x5 and n_x6 and x7 and x8 and x9;
   t_101 <= n_x0 and n_x1 and n_x2 and n_x3 and n_x4 and n_x5 and x6 and x7 and x8 and x9;
   t_102 <= x0 and n_x1 and n_x2 and n_x3 and n_x4 and n_x5 and n_x6 and x7 and x8 and x9;
   t_103 <= n_x0 and n_x1 and x2 and n_x3 and n_x4 and n_x5 and n_x6 and x7 and x8 and x9;
   t_104 <= n_x0 and n_x1 and n_x2 and x3 and n_x4 and n_x5 and n_x6 and x7 and x8 and x9;
   t_105 <= n_x0 and x1 and n_x2 and n_x3 and n_x4 and n_x5 and n_x6 and x7 and x8 and x9;
   t_106 <= x0 and n_x1 and n_x2 and n_x3 and n_x4 and n_x5 and n_x6 and x7 and x8 and x9;
   t_107 <= n_x0 and n_x1 and x2 and n_x3 and n_x4 and n_x5 and n_x6 and x7 and x8 and x9;
   t_108 <= n_x0 and n_x1 and n_x2 and x3 and n_x4 and n_x5 and n_x6 and x7 and x8 and x9;
   t_109 <= n_x0 and n_x1 and n_x2 and n_x3 and x4 and n_x5 and n_x6 and x7 and x8 and x9;
   t_110 <= n_x0 and n_x1 and n_x2 and n_x3 and n_x4 and x5 and n_x6 and x7 and x8 and x9;
   t_111 <= n_x0 and n_x1 and n_x2 and n_x3 and n_x4 and n_x5 and x6 and x7 and x8 and x9;
   t_112 <= x0 and x1;
   t_113 <= x0 and x2;
   t_114 <= x0 and x3;
   t_115 <= x0 and x4;
   t_116 <= x0 and x5;
   t_117 <= x0 and x6;
   t_118 <= n_x0 and n_x1 and n_x2 and n_x3 and n_x4 and n_x5 and n_x6;
   t_119 <= x1 and x2;
   t_120 <= x1 and x3;
   t_121 <= x1 and x4;
   t_122 <= x1 and x5;
   t_123 <= x1 and x6;
   t_124 <= x2 and x3;
   t_125 <= x2 and x4;
   t_126 <= x2 and x5;
   t_127 <= x2 and x6;
   t_128 <= x3 and x4;
   t_129 <= x3 and x5;
   t_130 <= x3 and x6;
   t_131 <= x4 and x5;
   t_132 <= x4 and x6;
   t_133 <= x5 and x6;

   y0 <= t_0 or t_1 or t_2 or t_28 or t_29 or t_30 or t_42 or t_43 or t_44 or t_70 or t_71 or t_84;
   y1 <= t_14 or t_15 or t_16 or t_56 or t_57 or t_85 or t_86 or t_87 or t_98 or t_99 or t_100 or t_101;
   y2 <= t_3 or t_4 or t_5 or t_6 or t_31 or t_32 or t_33 or t_34 or t_58 or t_59 or t_60 or t_61 or t_62;
   y3 <= t_17 or t_18 or t_19 or t_20 or t_45 or t_46;
   y4 <= t_47 or t_48 or t_72 or t_73 or t_74 or t_75 or t_76 or t_88 or t_89 or t_90;
   y5 <= t_102 or t_103;
   y6 <= t_104;
   y7 <= t_12 or t_13 or t_26 or t_27 or t_39 or t_40 or t_41 or t_53 or t_54 or t_55 or t_67 or t_68 or t_69 or t_81 or t_82 or t_83 or t_94 or t_95 or t_96 or t_97 or t_108 or t_109 or t_110 or t_111;
   y8 <= t_9 or t_10 or t_11 or t_23 or t_24 or t_25 or t_37 or t_38 or t_51 or t_52 or t_65 or t_66 or t_92 or t_93 or t_106 or t_107;
   y9 <= t_35 or t_36 or t_49 or t_50 or t_53 or t_54 or t_55 or t_63 or t_64 or t_67 or t_68 or t_69 or t_79 or t_80 or t_83 or t_97 or t_109 or t_110 or t_111;
   y10 <= t_7 or t_8 or t_12 or t_13 or t_21 or t_22 or t_26 or t_27 or t_37 or t_38 or t_51 or t_52 or t_77 or t_78 or t_81 or t_82 or t_92 or t_93;
   y11 <= t_9 or t_10 or t_11 or t_23 or t_24 or t_25 or t_39 or t_40 or t_41 or t_53 or t_54 or t_55 or t_63 or t_64 or t_79 or t_80 or t_91 or t_94 or t_95 or t_96 or t_105 or t_109 or t_110 or t_111;
end PLA;
